import { Pipe } from '@angular/core';
import { isNumberFinite } from '../helpers/helpers';
var BytesPipe = (function () {
    function BytesPipe() {
        this.dictionary = [
            { max: 1e3, type: 'B' },
            { max: 1e6, type: 'KB' },
            { max: 1e9, type: 'MB' },
            { max: 1e12, type: 'GB' }
        ];
    }
    BytesPipe.prototype.transform = function (value) {
        if (!isNumberFinite(value)) {
            return NaN;
        }
        var format = this.dictionary.find(function (d) { return value < d.max; }) || this.dictionary[this.dictionary.length - 1];
        var num = value / (format.max / 1e3);
        return num + " " + format.type;
    };
    return BytesPipe;
}());
export { BytesPipe };
BytesPipe.decorators = [
    { type: Pipe, args: [{ name: 'bytes' },] },
];
/** @nocollapse */
BytesPipe.ctorParameters = function () { return []; };
//# sourceMappingURL=bytes.js.map