"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var helpers_1 = require("../helpers/helpers");
var FilterByPipe = (function () {
    function FilterByPipe() {
    }
    FilterByPipe.prototype.transform = function (input, props, search, strict) {
        if (search === void 0) { search = ''; }
        if (strict === void 0) { strict = false; }
        if (!Array.isArray(input) || (!helpers_1.isString(search) && !helpers_1.isNumberFinite(search) && !helpers_1.isBoolean(search))) {
            return input;
        }
        var term = String(search).toLowerCase();
        return input.filter(function (obj) {
            return props.some(function (prop) {
                var value = helpers_1.extractDeepPropertyByMapKey(obj, prop), strValue = String(value).toLowerCase();
                if (helpers_1.isUndefined(value)) {
                    return false;
                }
                return strict
                    ? term === strValue
                    : !!~strValue.indexOf(term);
            });
        });
    };
    return FilterByPipe;
}());
FilterByPipe.decorators = [
    { type: core_1.Pipe, args: [{ name: 'filterBy', pure: false },] },
];
/** @nocollapse */
FilterByPipe.ctorParameters = function () { return []; };
exports.FilterByPipe = FilterByPipe;
//# sourceMappingURL=filter-by.js.map